﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
namespace HeuristicLab.Services.Hive {
  public interface IAuthorizationManager {
    /// <summary>
    /// Returns the UserId of the currently authenticated user
    /// </summary>
    Guid UserId { get; }

    /// <summary>
    /// Checks if the user is allowed to access all the jobs.
    /// throws an exception if one of those jobs is inaccessible
    /// </summary>
    /// <exception cref="SecurityException">thrown when access denied</exception>
    //void AuthorizeJobs(params Guid[] jobId);

    /// <summary>
    /// Compares the current UserId with the given userId and takes appropriate actions if the mismatch
    /// </summary>
    void Authorize(Guid userId);
  }
}
